
-- CONFIGURATION ----------------------------------


local show_all_bags = false


-- END OF CONFIG ----------------------------------




local level = UnitLevel("player")


-- ACTIONBARS -------------------------------------
---------------------------------------------------

UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarBottomRight'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarRight'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['MultiBarLeft'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['ContainerFrame1'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['ContainerFrame2'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['ContainerFrame3'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['ContainerFrame4'] = nil
UIPARENT_MANAGED_FRAME_POSITIONS['ContainerFrame5'] = nil


-- Hide textures
for _, texture in ipairs({


	-- End caps
	MainMenuBarLeftEndCap,
	MainMenuBarRightEndCap,


	-- Pet actionbar
	SlidingActionBarTexture0,
	SlidingActionBarTexture1,


	-- Shapeshift bar
	ShapeshiftBarLeft,
	ShapeshiftBarRight,
	ShapeshiftBarMiddle,


	-- Experience bar
	MainMenuXPBarTextureLeftCap,
	MainMenuXPBarTextureMid,
	MainMenuXPBarTextureRightCap,


	-- Experience bar, max level
	MainMenuMaxLevelBar0,
	MainMenuMaxLevelBar1,
	MainMenuMaxLevelBar2,
	MainMenuMaxLevelBar3,


	-- Reputation bar
	ReputationWatchBarTexture0,
	ReputationWatchBarTexture1,
	ReputationWatchBarTexture2,
	ReputationWatchBarTexture3,


	-- Reputation bar, max level
	ReputationXPBarTexture0,
	ReputationXPBarTexture1,
	ReputationXPBarTexture2,
	ReputationXPBarTexture3,


	-- Experience bar, divs
	MainMenuXPBarDiv1,
	MainMenuXPBarDiv2,
	MainMenuXPBarDiv3,
	MainMenuXPBarDiv4,
	MainMenuXPBarDiv5,
	MainMenuXPBarDiv6,
	MainMenuXPBarDiv7,
	MainMenuXPBarDiv8,
	MainMenuXPBarDiv9,
	MainMenuXPBarDiv10,
	MainMenuXPBarDiv11,
	MainMenuXPBarDiv12,
	MainMenuXPBarDiv13,
	MainMenuXPBarDiv14,
	MainMenuXPBarDiv15,
	MainMenuXPBarDiv16,
	MainMenuXPBarDiv17,
	MainMenuXPBarDiv18,
	MainMenuXPBarDiv19,

	}) do
	texture:SetTexture(nil)
end


-- Hide frames
for _, frame in ipairs({


	-- Boncus action bar
	BonusActionBarFrameTexture1,
	BonusActionBarFrameTexture2,
	BonusActionBarFrameTexture3,
	BonusActionBarFrameTexture4,


	-- Main menu bar
	MainMenuBarTexture0,
	MainMenuBarTexture1,
	MainMenuBarTexture2,
	MainMenuBarTexture3,


	-- Exhaustion tick
	ExhaustionTick,

	}) do
	frame:SetAlpha(0)
end


-- Move "bottom right" actionbar
MultiBarBottomRight:ClearAllPoints()
MultiBarBottomRight:SetPoint("BOTTOM", 250, 4)


-- Move "multibar right" and make it horizontal
for i=1,12 do 
	_G["MultiBarRightButton"..i]:ClearAllPoints()
	_G["MultiBarRightButton"..i]:SetPoint("BOTTOM", MultiBarBottomLeft, "BOTTOM", 230+i*42, 0)
end


-- Move "multibar left" to replace "multibar right"
MultiBarLeft:ClearAllPoints()
MultiBarLeft:SetPoint("RIGHT", UIParent, "RIGHT", 0, -50)


-- Move main actionbar paging buttons
ActionBarUpButton:SetPoint("LEFT", -22, 5)
ActionBarDownButton:SetPoint("LEFT", -22, -14)
MainMenuBarPageNumber:SetPoint("TOP", ActionBarUpButton, "TOP", 0, 8)
ActionBarDownButton:SetParent(ActionBarUpButton)	-- For mouseover
MainMenuBarPageNumber:SetParent(ActionBarUpButton)	-- For mouseover


-- Vehicle bar
VehicleMenuBar:SetScale(0.85)
VehicleMenuBarArtFrame:Hide()


-- Move XP and reputation bars
local xpBarsFix = CreateFrame("Frame")

xpBarsFix:SetScript("OnEvent", function(xpBarsFix, event, addon)
	if level == 85 then
		ReputationWatchBar:SetParent(MainMenuBar)
		ReputationWatchBar:SetPoint("TOPLEFT", MainMenuBar, "TOPLEFT", 6, 3)
		ReputationWatchBar.SetPoint = function() end
		ReputationWatchBar:SetScale(0.982)
	else
		MainMenuExpBar:SetParent(MainMenuBar)
		MainMenuExpBar:SetPoint("TOPLEFT", MainMenuBar, "TOPLEFT", 6, 2)
		MainMenuExpBar:SetWidth(1005)
		ReputationWatchBar:SetParent(MainMenuBar)
		ReputationWatchBar:SetPoint("TOPLEFT", MainMenuBar, "TOPLEFT", 6, 10)
		ReputationWatchBar.SetPoint = function() end
		ReputationWatchBar:SetScale(0.982)
	end
end)

xpBarsFix:RegisterEvent("PLAYER_ENTERING_WORLD")
xpBarsFix:RegisterEvent("PLAYER_LEVEL_UP")
xpBarsFix:RegisterEvent("PLAYER_XP_UPDATE")
xpBarsFix:RegisterEvent("PLAYER_TALENT_UPDATE")
xpBarsFix:RegisterEvent("UNIT_EXITED_VEHICLE")


-- Fix for Blizzards disappearing action button textures >_>
hooksecurefunc("ActionButton_ShowGrid", function(btn)
	_G[btn:GetName().."NormalTexture"]:SetVertexColor(1, 1, 1, 1)
end)




-- BAGS -------------------------------------------
---------------------------------------------------

-- Create holder frame to prevent glitchy mouseover
local BagHolder = CreateFrame("Frame", "BagHolder", UIParent)
BagHolder:SetHeight(35)
BagHolder:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, 0)


-- Show all bags
if show_all_bags then
	BagHolder:SetWidth(160)
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", BagHolder, "BOTTOMRIGHT", -4, 4)
	MainMenuBarBackpackButton:SetScale(0.7)
	MainMenuBarBackpackButton:SetParent(BagHolder)
	KeyRingButton:SetParent(BagHolder)
	KeyRingButton:SetScale(0.7)

	for i=0,3 do
		_G["CharacterBag"..i.."Slot"]:SetParent(BagHolder)
		_G["CharacterBag"..i.."Slot"]:SetScale(0.8)
	end
end


-- Show only backpack
if not show_all_bags then
	BagHolder:SetWidth(50)
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", BagHolder, "BOTTOMRIGHT", -4, 4)
	MainMenuBarBackpackButton:SetScale(0.7)
	MainMenuBarBackpackButton:SetParent(BagHolder)
	KeyRingButton:ClearAllPoints()
	KeyRingButton:SetPoint("BOTTOMLEFT", MainMenuBarBackpackButton, "BOTTOMLEFT", -22, -1)
	KeyRingButton:SetParent(BagHolder)
	KeyRingButton:SetScale(0.7)

	for i=0,3 do
		_G["CharacterBag"..i.."Slot"]:Hide()
	end

	-- Open all bags when clicking on the backpack
	MainMenuBarBackpackButton:SetScript("OnClick", function(self)
		OpenAllBags()
	end)
end


-- Scale bag container frames
for i=1,6 do
	_G["ContainerFrame"..i]:SetScale(0.9)
	_G["ContainerFrame"..i].SetScale = function() end
end




-- MICRO MENU -------------------------------------
-- Credit: Roth -----------------------------------

-- Holder frame
local fmicro = CreateFrame("Frame", "MicroMenuHolder", MinimapCluster)
fmicro:SetWidth(255)
fmicro:SetHeight(40)
fmicro:SetPoint("BOTTOM", Minimap, -2, -58)
fmicro:SetScale(0.7)


-- Move the micro menu
local MicroButtons = {
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	PVPMicroButton,
	LFDMicroButton,
	MainMenuMicroButton,
	HelpMicroButton,
}

local function MoveMicroMenu()
	for _, f in pairs(MicroButtons) do
		f:SetParent(fmicro)
	end
	CharacterMicroButton:ClearAllPoints()
	CharacterMicroButton:SetPoint("BOTTOMLEFT", 2, 2)
	GuildMicroButton:ClearAllPoints()
	GuildMicroButton:SetPoint("BOTTOMRIGHT", QuestLogMicroButton, 24, 0)
end


-- Hook into Blizzard functions to keep my frame position when entering a vehicle
hooksecurefunc("VehicleMenuBar_MoveMicroButtons", MoveMicroMenu)
MoveMicroMenu()




-- MINIMAP ----------------------------------------
---------------------------------------------------

MinimapCluster:ClearAllPoints()
MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -4, 4)




-- WATCH FRAME (QUEST TRACKER) --------------------
---------------------------------------------------

-- Ghetto fix to move Watch Frame without taint
MinimapCluster:SetHeight(225)
MinimapBorder:ClearAllPoints()
MinimapBorder:SetPoint("TOP", 0, 18)
MinimapBorder:SetSize(192, 192)


-- target dead text font