
-- Clean up the minimap
MinimapCluster:SetScale(0.9)
Minimap:SetMaskTexture('Interface\\Buttons\\WHITE8x8')
MinimapBorder:SetTexture("Interface\\AddOns\\SainUI\\Textures\\UI-MINIMAP-BORDER.blp")
MinimapNorthTag:SetAlpha(0)
MinimapBorderTop:Hide()
MinimapZoneTextButton:Hide()
MiniMapWorldMapButton:Hide()


-- Dungeon difficulty indicator
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("BOTTOMLEFT", Minimap, -8, 100)


-- Calendar button
GameTimeFrame:ClearAllPoints()
GameTimeFrame:SetPoint("BOTTOMRIGHT", Minimap, -2, 0)
GameTimeFrame:SetScale(0.8)


-- Zoom buttons
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()


-- Tracking button
MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("TOPLEFT", Minimap, -4, 2)
select(1, MiniMapTracking:GetRegions()):SetTexture(nil)
select(1, MiniMapTrackingButton:GetRegions()):SetTexture(nil)


-- Mail icon
MiniMapMailIcon:SetTexture("Interface\\AddOns\\SainUI\\Textures\\Minimap-Mail-Icon.blp")
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPLEFT", Minimap, -3, -20)
MiniMapMailBorder:Hide()


-- LFG icon
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetPoint("BOTTOMLEFT", Minimap, -2, -2)
select(1, MiniMapLFGFrame:GetRegions()):SetTexture(nil)


-- PvP icon
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("BOTTOMLEFT", Minimap, -1, -2)
select(3, MiniMapBattlefieldFrame:GetRegions()):SetTexture(nil)


-- Clock
local minimapClock = CreateFrame("Frame")
local function fixMinimapClock(minimapClock, event, addon)
	if addon == "Blizzard_TimeManager" then
		select(1, TimeManagerClockButton:GetRegions()):SetTexture(nil)
		TimeManagerClockButton:ClearAllPoints()
		TimeManagerClockButton:SetPoint("TOPRIGHT", 5, 0)
		TimeManagerClockTicker:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 15, "OUTLINE")
	end
end
minimapClock:RegisterEvent("ADDON_LOADED")
minimapClock:SetScript("OnEvent", fixMinimapClock)


-- Allows mousewheel scrolling to zoom in and out
Minimap:EnableMouseWheel(true)
Minimap:SetScript('OnMouseWheel', function(self, delta)
	if delta > 0 then
		Minimap_ZoomIn()
	else
		Minimap_ZoomOut() 
	end
end)