local arenaEventHandler = CreateFrame("Frame")


-- Modify arena frames
local function setupArenaFrames()
	for i=1, MAX_ARENA_ENEMIES do
		_G["ArenaEnemyFrame"..i]:SetScale(1.5)
		_G["ArenaEnemyFrame"..i.."ClassPortrait"]:SetSize(26, 26)
		_G["ArenaEnemyFrame"..i.."ClassPortrait"]:ClearAllPoints()
		_G["ArenaEnemyFrame"..i.."ClassPortrait"]:SetPoint("TOPRIGHT", 0, -9)
		_G["ArenaEnemyFrame"..i.."HealthBar"]:ClearAllPoints()
		_G["ArenaEnemyFrame"..i.."HealthBar"]:SetPoint("TOPLEFT", 3, -10)
		_G["ArenaEnemyFrame"..i.."HealthBar"]:SetHeight(15)
		_G["ArenaEnemyFrame"..i.."HealthBar"]:SetWidth(71)
		_G["ArenaEnemyFrame"..i.."HealthBarText"]:ClearAllPoints()
		_G["ArenaEnemyFrame"..i.."HealthBarText"]:SetPoint("CENTER", -11, -1.5)
		_G["ArenaEnemyFrame"..i.."HealthBarText"]:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 9, "OUTLINE")
		_G["ArenaEnemyFrame"..i.."ManaBar"]:ClearAllPoints()
		_G["ArenaEnemyFrame"..i.."ManaBar"]:SetPoint("TOPLEFT", 3, -25)
		_G["ArenaEnemyFrame"..i.."ManaBar"]:SetHeight(9)
		_G["ArenaEnemyFrame"..i.."ManaBar"]:SetWidth(71)
		_G["ArenaEnemyFrame"..i.."ManaBarText"]:ClearAllPoints()
		_G["ArenaEnemyFrame"..i.."ManaBarText"]:SetPoint("CENTER", -11, -13)
		_G["ArenaEnemyFrame"..i.."ManaBarText"]:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 7, "OUTLINE")
		_G["ArenaEnemyFrame"..i.."Background"]:SetWidth(71)
		_G["ArenaEnemyFrame"..i.."Background"]:SetHeight(23)
		_G["ArenaEnemyFrame"..i.."Name"]:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
		_G["ArenaEnemyFrame"..i.."Texture"]:SetTexture("Interface\\AddOns\\SainUI_UnitFrames\\Textures\\UI-ArenaTargetingFrame.blp")

		_G["ArenaEnemyFrame"..i.."PetFrame"]:SetScale(0.01)	-- hidden until fixed
	end

	ArenaEnemyFrame1:ClearAllPoints()
	ArenaEnemyFrame1:SetPoint("RIGHT", UIParent, -80, 60)
end


-- Class colored names
local function colorNames()
	local _, arena1Class = UnitClass("arena1")
	local arena1Color = RAID_CLASS_COLORS[arena1Class]
	if not (arena1Color == nil) then
		ArenaEnemyFrame1Name:SetTextColor(arena1Color.r, arena1Color.g, arena1Color.b)
	end

	local _, arena2Class = UnitClass("arena2")
	local arena2Color = RAID_CLASS_COLORS[arena2Class]
	if not (arena2Color == nil) then
		ArenaEnemyFrame2Name:SetTextColor(arena2Color.r, arena2Color.g, arena2Color.b)
	end

	local _, arena3Class = UnitClass("arena3")
	local arena3Color = RAID_CLASS_COLORS[arena3Class]
	if not (arena3Color == nil) then
		ArenaEnemyFrame3Name:SetTextColor(arena3Color.r, arena3Color.g, arena3Color.b)
	end

	local _, arena4Class = UnitClass("arena4")
	local arena4Color = RAID_CLASS_COLORS[arena4Class]
	if not (arena4Color == nil) then
		ArenaEnemyFrame4Name:SetTextColor(arena4Color.r, arena4Color.g, arena4Color.b)
	end

	local _, arena5Class = UnitClass("arena5")
	local arena5Color = RAID_CLASS_COLORS[arena5Class]
	if not (arena5Color == nil) then
		ArenaEnemyFrame5Name:SetTextColor(arena5Color.r, arena5Color.g, arena5Color.b)
	end
end


-- Events
arenaEventHandler:RegisterEvent("ADDON_LOADED")
arenaEventHandler:RegisterEvent("ARENA_OPPONENT_UPDATE")

arenaEventHandler:SetScript("OnEvent", function(self, event, arg1)
	if (event == "ADDON_LOADED") then
		if (IsAddOnLoaded("Blizzard_ArenaUI")) then
			setupArenaFrames()
		end
	end

	if (event == "ARENA_OPPONENT_UPDATE") then
		colorNames()
	end
end)

--arenaEventHandler:RegisterEvent("UNIT_NAME_UPDATE")