
-- CONFIGURATION ----------------------------------


-- Change these values to move the frames to costum positions
local frame = {
	["PlayerFrame"]  = {
		position = {"TOPLEFT", UIParent, -35, 0,};	-- -35, 0
		scale = 1.2
	},
	["TargetFrame"]  = {
		position = {"TOPLEFT", UIParent, 205, 0};	-- 205, 0
		scale = 1.2
	},
	["TargetFrameToT"]  = {
		position = {"TOPRIGHT", TargetFrame, "TOPRIGHT", 50, -24};
		scale = 1
	},
	["PetFrame"]  = {
		position = {"BOTTOMLEFT", PlayerFrame, "BOTTOMLEFT", 54, -25};
		scale = 1
	},
};


-- END OF CONFIG ----------------------------------




local eventHandler = CreateFrame("frame")
local _, class = UnitClass("player")
local lc, lcl = IsAddOnLoaded("LoseControl"), IsAddOnLoaded("LoseControlLite")


-- GET UNIT FRAMES IN PLACE -----------------------
---------------------------------------------------

-- Player frame
local function posPlayerFrame()
	PlayerFrame:ClearAllPoints()
	PlayerFrame:SetPoint(unpack(frame["PlayerFrame"].position));
	RuneFrame:ClearAllPoints()
	RuneFrame:SetPoint("TOP", PlayerFrame, "BOTTOM", 59, 35)
	RuneFrame:SetScale(1.1)
	PlayerLeaderIcon:ClearAllPoints()
	PlayerLeaderIcon:SetPoint("TOPLEFT", 62, -22)
end


-- Target frame
TargetFrame:ClearAllPoints()
TargetFrame:SetPoint(unpack(frame["TargetFrame"].position));
	

-- Target of target frame
TargetFrameToT:ClearAllPoints()
TargetFrameToT:SetPoint(unpack(frame["TargetFrameToT"].position));


-- Pet frame
local pa, pb, pc, pd, pe = unpack(frame["PetFrame"].position);

if (pe == -25) and (class == "SHAMAN") then
	PetFrame:ClearAllPoints()
	PetFrame:SetPoint(pa, pb, pc, pd, pe-25)
elseif (pe == -25) and (class == "WARLOCK" or class == "DRUID") then
	PetFrame:ClearAllPoints()
	PetFrame:SetPoint(pa, pb, pc, pd, pe-10)
else
	PetFrame:ClearAllPoints()
	PetFrame:SetPoint(pa, pb, pc, pd, pe)
end




-- SET UNITFRAME SCALE ----------------------------
---------------------------------------------------

PlayerFrame:SetScale(frame["PlayerFrame"].scale)
TargetFrame:SetScale(frame["TargetFrame"].scale)
TargetFrameToT:SetScale(frame["TargetFrameToT"].scale)
PetFrame:SetScale(frame["PetFrame"].scale)




-- CUSTOMIZE PLAYER FRAME -------------------------
---------------------------------------------------

-- Player
PlayerPortrait:SetSize(42, 42)
PlayerPortrait:SetPoint("TOPLEFT", 60, -22)
PlayerHitIndicator:SetText("")
PlayerHitIndicator.SetText = function() end
PlayerFrameFlash:ClearAllPoints()
PlayerFrameFlash:SetPoint("TOPLEFT", 14, 0)
PlayerFrameGroupIndicatorLeft:SetTexture(nil)
PlayerFrameGroupIndicatorRight:SetTexture(nil)
PlayerFrameGroupIndicatorMiddle:SetTexture(nil)
PlayerPVPTimerText:ClearAllPoints()
PlayerPVPTimerText:SetPoint("CENTER", PlayerFrame, "TOPLEFT", 82, -12)
PlayerAttackIcon:SetSize(18, 18)
PlayerAttackIcon:ClearAllPoints()
PlayerAttackIcon:SetPoint("BOTTOMLEFT", 60, 35)
PlayerPVPIcon:SetAlpha(0)
PlayerLevelText:SetAlpha(0)
PlayerRestGlow:SetAlpha(0)
PlayerRestIcon:SetAlpha(0)
PlayerGuideIcon:SetAlpha(0)
PlayerMasterIcon:SetAlpha(0)
PlayerFrameRoleIcon:SetAlpha(0)
PlayerSpeakerFrame:SetAlpha(0)
PlayerFrameReadyCheck:SetAlpha(0)
PlayerLeaderIcon:SetSize(12, 12)
PlayerFrameGroupIndicatorText:SetAlpha(0.5)


-- Player enters world or leaves vehicle
local function setupPlayerFrame()
	PlayerName:ClearAllPoints()
	PlayerName:SetPoint("CENTER", 50, 20.5)
	PlayerFrameHealthBar:ClearAllPoints()
	PlayerFrameHealthBar:SetPoint("TOPLEFT", 107, -38)
	PlayerFrameHealthBar:SetHeight(17)
	PlayerFrameHealthBarText:ClearAllPoints()
	PlayerFrameHealthBarText:SetPoint("CENTER", 50, 3.5)
	PlayerFrameManaBar:ClearAllPoints()
	PlayerFrameManaBar:SetPoint("TOPLEFT", 107, -55)
	PlayerFrameManaBar:SetHeight(10)
	PlayerFrameManaBarText:ClearAllPoints()
	PlayerFrameManaBarText:SetPoint("CENTER", 50, -10)
end


--[[ Player enters vehicle
local function setupVehicleFrame()
	PlayerName:ClearAllPoints()
	PlayerName:SetPoint("CENTER", 47, 18)
	PlayerFrameHealthBar:ClearAllPoints()
	PlayerFrameHealthBar:SetPoint("TOPLEFT", 106, -40)
	PlayerFrameHealthBar:SetWidth(113)
	PlayerFrameManaBar:ClearAllPoints()
	PlayerFrameManaBar:SetPoint("TOPLEFT", 106, -55)
	PlayerFrameManaBar:SetWidth(113)
end
]]


-- Combo points frame
ComboFrame:SetScale(frame["TargetFrame"].scale)
ComboFrame:ClearAllPoints()
ComboFrame:SetPoint("TOPRIGHT", TargetFrame, -47, -22)
ComboPoint2:ClearAllPoints()
ComboPoint2:SetPoint("TOP", ComboPoint1, "BOTTOM", 0, 4)
ComboPoint3:ClearAllPoints()
ComboPoint3:SetPoint("TOP", ComboPoint2, "BOTTOM", 0, 4)
ComboPoint4:ClearAllPoints()
ComboPoint4:SetPoint("TOP", ComboPoint3, "BOTTOM", 0, 4)
ComboPoint5:ClearAllPoints()
ComboPoint5:SetPoint("TOP", ComboPoint4, "BOTTOM", 1, 4)


-- Feral mana bar
PlayerFrameAlternateManaBar:ClearAllPoints()
PlayerFrameAlternateManaBar:SetPoint("BOTTOMLEFT", 127, 23)
PlayerFrameAlternateManaBar:SetWidth(80)
PlayerFrameAlternateManaBarBorder:SetTexture("Interface\\AddOns\\SainUI_UnitFrames\\Textures\\UI-CHARACTERFRAME-GROUPINDICATOR.blp")


-- Moonkin eclispe bar
EclipseBarFrame:SetScale(0.9)
EclipseBarFrame:ClearAllPoints()
EclipseBarFrame:SetPoint("TOP", PlayerFrame, "BOTTOM", 56, 43)


-- Paladin power bar
PaladinPowerBar:SetScale(0.9)
PaladinPowerBar:ClearAllPoints()
PaladinPowerBar:SetPoint("TOP", PlayerFrame, "BOTTOM", 56, 45)


-- Warlock Shard bar
ShardBarFrame:SetScale(0.9)
ShardBarFrame:ClearAllPoints()
ShardBarFrame:SetPoint("TOP", PlayerFrame, "BOTTOM", 60, 39)


-- Totem bar
TotemFrame:SetScale(0.9)

for i=1,4 do
	_G["TotemFrameTotem"..i.."Background"]:SetTexture(nil)
end




-- CUSTOMIZE TARGET FRAME -------------------------
---------------------------------------------------

TargetFramePortrait:SetSize(42, 42)
TargetFramePortrait:SetPoint("TOPRIGHT", -60, -22)
TargetFrameTextureFrameName:ClearAllPoints()
TargetFrameTextureFrameName:SetPoint("CENTER", -50, 20.5)
TargetFrameHealthBar:ClearAllPoints()
TargetFrameHealthBar:SetPoint("TOPRIGHT", -106, -38)
TargetFrameHealthBar:SetHeight(17)
TargetFrameTextureFrameHealthBarText:ClearAllPoints()
TargetFrameTextureFrameHealthBarText:SetPoint("CENTER", -50, 3.5)
TargetFrameManaBar:ClearAllPoints()
TargetFrameManaBar:SetPoint("TOPRIGHT", -106, -55)
TargetFrameManaBar:SetHeight(10)
TargetFrameTextureFrameManaBarText:ClearAllPoints()
TargetFrameTextureFrameManaBarText:SetPoint("CENTER", -50, -10)
TargetFrameTextureFramePVPIcon:SetAlpha(0)
TargetFrameTextureFrameRaidTargetIcon:ClearAllPoints()
TargetFrameTextureFrameRaidTargetIcon:SetPoint("TOPRIGHT", -73, -15)
TargetFrameTextureFrameRaidTargetIcon:SetSize(15, 15)
TargetFrameNumericalThreat:SetPoint("BOTTOM", 35, 20)
TargetFrameNumericalThreatBG:SetAlpha(0.8)
TargetFrameNumericalThreatBG:SetWidth(32)
TargetFrameNumericalThreatBG:SetHeight(12)
TargetFrameNumericalThreatBG:ClearAllPoints()
TargetFrameNumericalThreatBG:SetPoint("TOP", 0, -3)
TargetFrameNumericalThreatValue:SetPoint("TOP", 1, -3)
TargetFrameTextureFrameLevelText:ClearAllPoints()
TargetFrameTextureFrameLevelText:SetPoint("CENTER", 50, -7)
TargetFrameTextureFrameHighLevelTexture:ClearAllPoints()
TargetFrameTextureFrameHighLevelTexture:SetPoint("CENTER", TargetFrameTextureFrameLevelText, 0, 0)
TargetFrameTextureFrameLeaderIcon:SetSize(12, 12)
TargetFrameTextureFrameLeaderIcon:ClearAllPoints()
TargetFrameTextureFrameLeaderIcon:SetPoint("TOPRIGHT", -61, -22)
TargetFrameTextureFrameQuestIcon:ClearAllPoints()
TargetFrameTextureFrameQuestIcon:SetPoint("TOPLEFT", TargetFrame, "TOPRIGHT", -120, -12)
TargetFrameNameBackground:SetHeight(17)




-- CUSTOMIZE ToT FRAME ----------------------------
---------------------------------------------------

TargetFrameToTBackground:SetWidth(50)
TargetFrameToTBackground:SetHeight(20)
TargetFrameToTBackground:ClearAllPoints()
TargetFrameToTBackground:SetPoint("BOTTOMLEFT", 43, 5)
TargetFrameToTPortrait:ClearAllPoints()
TargetFrameToTPortrait:SetPoint("TOPLEFT", 3, -6)
TargetFrameToTPortrait:SetSize(34, 34)
TargetFrameToTHealthBar:SetHeight(12)
TargetFrameToTHealthBar:SetWidth(50)
TargetFrameToTHealthBar:ClearAllPoints()
TargetFrameToTHealthBar:SetPoint("TOPRIGHT", 0, -20)
TargetFrameToTManaBar:ClearAllPoints()
TargetFrameToTManaBar:SetPoint("TOPRIGHT", 0, -33)
TargetFrameToTManaBar:SetWidth(50)
TargetFrameToTTextureFrameName:ClearAllPoints()
TargetFrameToTTextureFrameName:SetPoint("BOTTOMLEFT", 43, 28)
TargetFrameToTTextureFrameName.SetPoint = function() end
TargetFrameToTDebuff1:ClearAllPoints()
TargetFrameToTDebuff1:SetPoint("BOTTOMLEFT", 40, -14)
TargetFrameToTDebuff3:ClearAllPoints()
TargetFrameToTDebuff3:SetPoint("TOPRIGHT", TargetFrameToTDebuff2, 14, 0)

TargetFrameToTTextureFrameDeadText:ClearAllPoints()
TargetFrameToTTextureFrameDeadText:SetPoint("CENTER", 15, -3)	-- FIXA




-- CUSTOMIZE FOCUS FRAME --------------------------
---------------------------------------------------

FocusFramePortrait:SetSize(40, 40)
FocusFramePortrait:SetPoint("TOPRIGHT", -60, -23)
FocusFrameHealthBar:ClearAllPoints()
FocusFrameHealthBar:SetPoint("TOPRIGHT", -106, -40)
FocusFrameHealthBar:SetHeight(14); 
FocusFrameManaBar:ClearAllPoints()
FocusFrameManaBar:SetPoint("TOPRIGHT", -106, -53)
FocusFrameManaBar:SetHeight(10)
FocusFrameTextureFrameLevelText:SetAlpha(0)
FocusFrameTextureFramePVPIcon:SetAlpha(0)
FocusFrameTextureFrameName:ClearAllPoints()
FocusFrameTextureFrameName:SetPoint("CENTER", -50, 20)
FocusFrameTextureFrameManaBarText:ClearAllPoints()
FocusFrameTextureFrameManaBarText:SetPoint("CENTER", -50, -10)
FocusFrameTextureFrameRaidTargetIcon:ClearAllPoints()
FocusFrameTextureFrameRaidTargetIcon:SetPoint("TOPRIGHT", -73, -15)
FocusFrameTextureFrameRaidTargetIcon:SetSize(15, 15)
FocusFrameNumericalThreat:SetPoint("BOTTOM", 35, 20)
FocusFrameNumericalThreatBG:SetAlpha(0.8)
FocusFrameNumericalThreatBG:SetWidth(32)
FocusFrameNumericalThreatBG:SetHeight(12)
FocusFrameNumericalThreatBG:ClearAllPoints()
FocusFrameNumericalThreatBG:SetPoint("TOP", 0, -3)
FocusFrameNumericalThreatValue:SetPoint("TOP", 1, -3)
FocusFrameTextureFrameLevelText:ClearAllPoints()
FocusFrameTextureFrameLevelText:SetPoint("CENTER", 50, -7)
FocusFrameTextureFrameHighLevelTexture:ClearAllPoints()
FocusFrameTextureFrameHighLevelTexture:SetPoint("CENTER", FocusFrameTextureFrameLevelText, 0, 0)
FocusFrameTextureFrameLeaderIcon:SetAlpha(0)




-- CUSTOMIZE FOCUS ToT FRAME ----------------------
---------------------------------------------------

local function setupFocusToTFrame()
	if not (UnitAffectingCombat("player")) then
		FocusFrameToT:ClearAllPoints()
		FocusFrameToT:SetPoint("BOTTOMRIGHT", FocusFrame, "BOTTOMRIGHT", 40, 31)
		FocusFrameToTBackground:SetWidth(50)
		FocusFrameToTBackground:SetHeight(20)
		FocusFrameToTBackground:ClearAllPoints()
		FocusFrameToTBackground:SetPoint("BOTTOMLEFT", 43, 5)
		FocusFrameToTHealthBar:SetHeight(10)
		FocusFrameToTHealthBar:SetWidth(48)
		FocusFrameToTHealthBar:ClearAllPoints()
		FocusFrameToTHealthBar:SetPoint("TOPRIGHT", -2, -21)
		FocusFrameToTManaBar:SetWidth(48)
		FocusFrameToTManaBar:ClearAllPoints()
		FocusFrameToTManaBar:SetPoint("TOPRIGHT", -2, -33)
		FocusFrameToTTextureFrameName:ClearAllPoints()
		FocusFrameToTTextureFrameName:SetPoint("BOTTOMLEFT", 43, 28)
	else
		eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end




-- CUSTOMIZE PET FRAME ----------------------------
---------------------------------------------------

PetPortrait:SetSize(34, 34)
PetPortrait:ClearAllPoints()
PetPortrait:SetPoint("TOPLEFT", 6, -11)
PetHitIndicator:SetText("")
PetHitIndicator.SetText = function() end
PetFrameHealthBar:SetHeight(15)
PetFrameHealthBar:ClearAllPoints()
PetFrameHealthBar:SetPoint("TOPLEFT", 46, -22)
PetFrameManaBar:ClearAllPoints()
PetFrameManaBar:SetPoint("TOPLEFT", 46, -37)
PetName:ClearAllPoints()
PetName:SetPoint("BOTTOMLEFT", 46, 33)
PetFrameHealthBarText:ClearAllPoints()
PetFrameHealthBarText:SetPoint("CENTER", PetFrame, "TOPLEFT", 82, -29.5)
PetFrameManaBarText:ClearAllPoints()
PetFrameManaBarText:SetPoint("CENTER", PetFrame, "TOPLEFT", 82, -41)
PetFrameHappiness:SetScale(0.65)
PetFrameHappiness:ClearAllPoints()
PetFrameHappiness:SetPoint("BOTTOMLEFT", 8, 12)
PetFrameHappiness:SetFrameStrata(HIGH)
PetFrameDebuff1:ClearAllPoints()
PetFrameDebuff1:SetPoint("TOPLEFT", PetFrame, 48, -50)



-- CUSTOMIZE PARTY FRAMES -------------------------
---------------------------------------------------

PartyMemberFrame1:ClearAllPoints()
PartyMemberFrame1:SetPoint("TOPLEFT", 19, -180)


for i=1,4 do
	_G["PartyMemberFrame"..i]:SetScale(1.1)
	_G["PartyMemberFrame"..i.."Background"]:SetHeight(23)
	_G["PartyMemberFrame"..i.."Background"]:SetPoint("TOPLEFT", 45, -22)
	_G["PartyMemberFrame"..i.."Portrait"]:SetSize(34, 34)
	_G["PartyMemberFrame"..i.."Name"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."Name"]:SetPoint("BOTTOMLEFT", 45, 34)
	_G["PartyMemberFrame"..i.."HealthBar"]:SetHeight(15)
	_G["PartyMemberFrame"..i.."HealthBar"]:SetWidth(71)
	_G["PartyMemberFrame"..i.."HealthBar"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."HealthBar"]:SetPoint("TOPLEFT", 45, -22)
	_G["PartyMemberFrame"..i.."HealthBarText"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."HealthBarText"]:SetPoint("CENTER", 20, -3)
	_G["PartyMemberFrame"..i.."ManaBar"]:SetHeight(8)
	_G["PartyMemberFrame"..i.."ManaBar"]:SetWidth(71)
	_G["PartyMemberFrame"..i.."ManaBar"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."ManaBar"]:SetPoint("TOPLEFT", 45, -37)
	_G["PartyMemberFrame"..i.."ManaBarText"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."ManaBarText"]:SetPoint("CENTER", 20, -14)
	_G["PartyMemberFrame"..i.."Debuff1"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."Debuff1"]:SetPoint("TOPLEFT", 125, -15)
	_G["PartyMemberFrame"..i.."Debuff3"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."Debuff3"]:SetPoint("TOPLEFT", 125, -30)
	_G["PartyMemberFrame"..i.."PetFrame"]:SetScale(1.0)
	_G["PartyMemberFrame"..i.."PetFramePortrait"]:SetSize(16, 16)
	_G["PartyMemberFrame"..i.."PetFramePortrait"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."PetFramePortrait"]:SetPoint("TOPLEFT", 3, -6)
	_G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetHeight(7)
	_G["PartyMemberFrame"..i.."PetFrameHealthBar"]:ClearAllPoints()
	_G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetPoint("TOPLEFT", 23, -11)
	
--	_G["PartyMemberFrame"..i.."VehicleTexture"]:SetTexture()
end


local function fixPartyPortrait()
	for i=1,4 do
		_G["PartyMemberFrame"..i.."Portrait"]:ClearAllPoints()
		_G["PartyMemberFrame"..i.."Portrait"]:SetPoint("TOPLEFT", 6, -11)
	end
end




-- SET FONTS --------------------------------------
---------------------------------------------------

-- Player
PlayerName:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
PlayerFrameHealthBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 11, "OUTLINE")
PlayerFrameManaBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 9, "OUTLINE")
PlayerFrameAlternateManaBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.ttf", 9, "OUTLINE")
PlayerPVPTimerText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 9)
PlayerFrameGroupIndicatorText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 9)


-- Target
TargetFrameTextureFrameName:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
TargetFrameTextureFrameHealthBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 11, "OUTLINE")
TargetFrameTextureFrameManaBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 9, "OUTLINE")
TargetFrameNumericalThreatValue:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
TargetFrameTextureFrameLevelText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 11, "OUTLINE")
TargetFrameTextureFrameDeadText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 11, "OUTLINE")


-- Target of target
TargetFrameToTTextureFrameName:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)


-- Focus
FocusFrameTextureFrameName:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
FocusFrameTextureFrameHealthBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 11, "OUTLINE")
FocusFrameTextureFrameManaBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 9, "OUTLINE")


-- Focus target of target
FocusFrameToTTextureFrameName:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)


-- Pet
PetName:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
PetFrameHealthBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10, "OUTLINE")
PetFrameManaBarText:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 8, "OUTLINE")


-- Party
for i=1,4 do
	_G["PartyMemberFrame"..i.."Name"]:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10)
	_G["PartyMemberFrame"..i.."HealthBarText"]:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 10, "OUTLINE")
	_G["PartyMemberFrame"..i.."ManaBarText"]:SetFont("Interface\\AddOns\\SainUI\\Fonts\\MYRIAD.TTF", 8, "OUTLINE")
end




-- SET TEXTURES -----------------------------------
---------------------------------------------------

-- Player
PlayerStatusTexture:SetTexture("Interface\\AddOns\\SainUI_UnitFrames\\Textures\\UI-Player-Status.blp")
PlayerAttackIcon:SetTexture(nil)
PlayerAttackBackground:SetTexture(nil)
select(2, PlayerStatusGlow:GetRegions()):SetTexture(nil)
PlayerFrameVehicleTexture:SetTexture("Interface\\AddOns\\SainUI_UnitFrames\\Textures\\UI-Vehicle-Frame.blp")
PlayerFrameVehicleTexture.SetTexture = function() end


-- Target
TargetFrameNameBackground:SetTexture("Interface\\AddOns\\SainUI_UnitFrames\\Textures\\UI-TargetingFrame-LevelBackground.blp")


-- Focus
FocusFrameNameBackground:SetTexture("Interface\\AddOns\\SainUI_UnitFrames\\Textures\\UI-TargetingFrame-LevelBackground.blp")


-- Pet
PetFrameFlash:SetTexture(nil)
PetAttackModeTexture:SetTexture(nil)




-- CLASS COLORED NAMES ----------------------------
---------------------------------------------------

-- Player
local function playerNameColor()
	local playerColor = RAID_CLASS_COLORS[class]
	PlayerName:SetTextColor(playerColor.r, playerColor.g, playerColor.b)
end


-- Target
local function targetNameColor()
	local isPlayer = UnitIsPlayer("target")
	local _, targetClass = UnitClass("target")
	local targetClassColor = RAID_CLASS_COLORS[targetClass]
	if (isPlayer == 1) and not (targetClassColor == nil) then
		TargetFrameTextureFrameName:SetTextColor(targetClassColor.r, targetClassColor.g, targetClassColor.b) 
	elseif (UnitIsTapped("target")) and (not UnitIsTappedByPlayer("target")) then
		TargetFrameTextureFrameName:SetTextColor(0.7, 0.7, 0.7)
	else
		TargetFrameTextureFrameName:SetTextColor(1, 0.8, 0)
	end
end


-- Target of target
local function totNameColor(target, ...)
	local totIsPlayer = UnitIsPlayer("targettarget")
	local _, totClass = UnitClass("targettarget")
	local totClassColor = RAID_CLASS_COLORS[totClass]
	if (totIsPlayer == 1) and not (totClassColor == nil) then
		TargetFrameToTTextureFrameName:SetTextColor(totClassColor.r, totClassColor.g, totClassColor.b)
	else
		TargetFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
	end
end


-- Focus
local function focusNameColor()
	local focusIsPlayer = UnitIsPlayer("focus")
	local _, focusClass = UnitClass("focus")
	local focusClassColor = RAID_CLASS_COLORS[focusClass]
	if (focusIsPlayer == 1) and not (focusClassColor == nil) then
		FocusFrameTextureFrameName:SetTextColor(focusClassColor.r, focusClassColor.g, focusClassColor.b)
	else
		FocusFrameTextureFrameName:SetTextColor(1, 0.8, 0)
	end
end


-- Focus target of target
local function focusToTNameColor(focus, ...)
	local focusToTIsPlayer = UnitIsPlayer("focustarget")
	local _, focusToTClass = UnitClass("focustarget")
	local focusToTClassColor = RAID_CLASS_COLORS[focusToTClass]
	if (focusToTIsPlayer == 1) and not (focusToTClassColor == nil) then
		FocusFrameToTTextureFrameName:SetTextColor(focusToTClassColor.r, focusToTClassColor.g, focusToTClassColor.b)
	else
		FocusFrameToTTextureFrameName:SetTextColor(1, 0.8, 0)
	end
end


-- Party frames
local function partyNameColor()
	local _, party1Class = UnitClass("party1")
	local party1ClassColor = RAID_CLASS_COLORS[party1Class]
	if not (party1ClassColor == nil) then
		PartyMemberFrame1Name:SetTextColor(party1ClassColor.r, party1ClassColor.g, party1ClassColor.b)
	end

	local _, party2Class = UnitClass("party2")
	local party2ClassColor = RAID_CLASS_COLORS[party2Class]
	if not (party2ClassColor == nil) then
		PartyMemberFrame2Name:SetTextColor(party2ClassColor.r, party2ClassColor.g, party2ClassColor.b)
	end

	local _, party3Class = UnitClass("party3")
	local party3ClassColor = RAID_CLASS_COLORS[party3Class]
	if not (party3ClassColor == nil) then
		PartyMemberFrame3Name:SetTextColor(party3ClassColor.r, party3ClassColor.g, party3ClassColor.b)
	end

	local _, party4Class = UnitClass("party4")
	local party4ClassColor = RAID_CLASS_COLORS[party4Class]
	if not (party4ClassColor == nil) then
		PartyMemberFrame4Name:SetTextColor(party4ClassColor.r, party4ClassColor.g, party4ClassColor.b)
	end
end




-- EVENTS -----------------------------------------
---------------------------------------------------

eventHandler:RegisterEvent("PLAYER_ENTERING_WORLD")
eventHandler:RegisterEvent("PLAYER_TARGET_CHANGED")
eventHandler:RegisterEvent("PLAYER_FOCUS_CHANGED")
eventHandler:RegisterEvent("PARTY_MEMBERS_CHANGED")
eventHandler:RegisterEvent("UNIT_TARGET")


eventHandler:SetScript("OnEvent", function(self, event, arg1)
	if (event == "PLAYER_ENTERING_WORLD") then
		posPlayerFrame()
		setupPlayerFrame()
		playerNameColor()
		setupFocusToTFrame()
	end

	if (event == "PLAYER_TARGET_CHANGED") then
		targetNameColor()
		totNameColor()
	end

	if (event == "PLAYER_FOCUS_CHANGED") then
		focusNameColor()
		focusToTNameColor()
	end

	if (event == "PLAYER_REGEN_ENABLED") then
		eventHandler:UnregisterEvent("PLAYER_REGEN_ENABLED")
		posPlayerFrame()
		setupPlayerFrame()
		fixPartyPortrait()
		PlayerFrame:SetAlpha(1)
	end

	if (event == "PARTY_MEMBERS_CHANGED") then
		partyNameColor()
	end

	if (event == "UNIT_TARGET") then
		totNameColor()
		focusToTNameColor()
	end
end)


-- Hooks to fix player frame
hooksecurefunc("PlayerFrame_AnimateOut", function()
	if not (UnitAffectingCombat("player")) then
		PlayerFrame:SetAlpha(0)
		posPlayerFrame()
	else
		eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end)


hooksecurefunc("PlayerFrame_SequenceFinished", function()
	PlayerFrame:SetAlpha(1)
	if not (UnitAffectingCombat("player")) then
		posPlayerFrame()
		setupPlayerFrame()
	else
		eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end)


-- Hooks to fix party frames
hooksecurefunc("PartyMemberFrame_ToPlayerArt", function()
	if not (UnitAffectingCombat("player")) then
		fixPartyPortrait()
	else
		eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end)

--[[
hooksecurefunc("PartyMemberFrame_ToVehicleArt", function()
	if not (UnitAffectingCombat("player")) then
		fixPartyPortrait()
	else
		eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
	end
end)
]]




-- FIX COMPATABILITY WITH ADDONS ------------------
---------------------------------------------------

-- LoseControl
if lc or lcl then
	LoseControlplayer:SetScale(0.76)
	LoseControltarget:SetScale(0.76)
	LoseControlfocus:SetScale(0.76)
	LoseControlarena1:SetScale(0.94)
	LoseControlarena2:SetScale(0.94)
	LoseControlarena3:SetScale(0.94)
	LoseControlarena4:SetScale(0.94)
	LoseControlarena5:SetScale(0.94)
end
